package com.github.itzilly.sbt

import net.minecraft.client.renderer.Tessellator
import net.minecraft.client.renderer.WorldRenderer
import net.minecraft.client.renderer.vertex.DefaultVertexFormats
import net.minecraft.util.AxisAlignedBB
import java.awt.Color


class RenderUtils {
    var TESSELLATOR: Tessellator = Tessellator.getInstance()
    var WORLD_RENDERER: WorldRenderer = Tessellator.getInstance().worldRenderer

    fun drawBlock(box: AxisAlignedBB, outlineStartColor: Int, outlineEndColor: Int) {
        drawBlockTop(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockBottom(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockNorth(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockEast(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockSouth(box, Color(outlineStartColor), Color(outlineEndColor));
        drawBlockWest(box, Color(outlineStartColor), Color(outlineEndColor));
    }

    private fun drawBlockTop(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockBottom(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockNorth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockEast(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockSouth(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.maxX, box.minY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.maxX, box.maxY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }

    private fun drawBlockWest(box: AxisAlignedBB, outlineStartColor: Color, outlineEndColor: Color) {
        WORLD_RENDERER.begin(2, DefaultVertexFormats.POSITION_COLOR)
        WORLD_RENDERER.pos(box.minX, box.maxY, box.minZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.maxY, box.maxZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.maxZ)
            .color(outlineStartColor.red, outlineStartColor.green, outlineStartColor.blue, outlineStartColor.alpha)
            .endVertex()
        WORLD_RENDERER.pos(box.minX, box.minY, box.minZ)
            .color(outlineEndColor.red, outlineEndColor.green, outlineEndColor.blue, outlineEndColor.alpha).endVertex()
        TESSELLATOR.draw()
    }
}